{-
TRABALHO DE LINGUAGENS DE PROGRAMAÇÃO - LP
Linguagem apresentada pelo grupo: HASKELL
Membros do Grupo:
	Breno Simão Bosgaglia
	Pablo Santana Satler
	Ramon Pereira de Matos

Professor: Vitor Souza
Ano/Semestre: 2013/2

-}

import System.Environment   
import System.Directory  
import System.IO  
import Data.List
import Data.List.Split --Biblioteca para usar a função splitOn. Teve que ser baixada -> sudo apt-get install cabal-install 
import System.IO.Error	-- No caso, cabal install split e cabal install exit
import System.Exit




leituraArqEntrada :: IO [String]
leituraArqEntrada = do
	entrada <- getArgs
	verifica entrada `catch` handler
	return entrada


-- Função de verificação da existência dos arquivos de entrada
-- ./trab_lp [-e, entregadores.csv, -c, cardapio.csv]
verifica :: [FilePath] -> IO () 
verifica [] = do 
	putStrLn "Arquivos de entrada nao especificados. Use: -e <entregadores> -c <cardapio>"
	exitFailure -- exita o programa
verifica [e1] = do
	putStrLn "Arquivos de entrada nao especificados. Use: -e <entregadores> -c <cardapio>"
	exitFailure
verifica [e1,e2] = do 
	putStrLn "Arquivos de entrada nao especificados. Use: -e <entregadores> -c <cardapio>"
	exitFailure
verifica [e1,e2,e3] = do 
	putStrLn "Arquivos de entrada nao especificados. Use: -e <entregadores> -c <cardapio>"
	exitFailure
verifica [e1,e2,e3,e4] = do 
	readFile e2 -- se um dos arquivos não existe, então é lançada uma exceção
	readFile e4 -- o qual é pega pela função handler definida abaixo
	putStr ""

-- Função de tratamento caso um arquivo especificado não exista 
handler :: IOError -> IO ()  
handler e 
    | isDoesNotExistError e = do
			putStrLn $ "Nao foi possível processar os arquivos especificados:" 
			exitFailure -- exita o programa
    | otherwise = do
			ioError e
			exitFailure  





-- ######################     FUNÇÕES RELACIONADAS AO CLIENTE (CADASTRO, BUSCA, ETC)        ##############################################

-- Função para cadastrar o cliente. 
-- Eh passado o telefone do cliente como parametro
cadastraCliente :: String -> String -> IO ()
cadastraCliente telefone arqCardapio = do
	putStr "Cliente nao cadastrado. Novo cadastro:\n"
	putStr "Nome:\n"
	nome <- getLine
	putStr "Endereco\n"
	endereco <- getLine
	putStr "Ponto de Referencia\n"
	referencia <- getLine
	let clienteLista = [nome ++ ";",endereco ++ ";",telefone ++ ";",referencia ++ ";"]
	appendFile "ClientesCadastrados.txt" ((unwords clienteLista) ++ "\n") -- para salvar no arquivo
	buscaCliente telefone arqCardapio

-- Retorna o numero do telefone digitado
pegaTelefone :: IO String
pegaTelefone = do
	putStr "Telefone (O para sair):\n"
	tel <- getLine
	return tel

-- Verifica se um determinado cliente existe na lista de clientes cadastrados
temNaLista :: [Char] -> [[Char]] -> Bool
temNaLista num [] = False
temNaLista num (primeiro:resto) = do
	let aux = splitOn ";" primeiro
	    teste = (" " ++ num) `elem` aux
	if teste
	then do
		True
	else do
		temNaLista num resto


-- Busca o nome do cliente dado seu numero de telefone
nomeDoCliente :: [Char] -> [[Char]] -> [[Char]]
nomeDoCliente num [] = []
nomeDoCliente num (primeiro:resto) = do
	let aux = splitOn ";" primeiro -- separa a string "primeiro" pela ocorrência de ";" em uma lista de string
	    teste = (" " ++ num) `elem` aux
	if teste
	then do
		aux
	else do
		nomeDoCliente num resto --Passa o numero do telefone, o resto da lista e a lista original
		

{- Função que busca um cliente na lista de cadastrados. Se o mesmo não for encontrado, então é feito o cadastro dele.
Se ele já é cadastrado, então pergunta se quer confirmar o cadastro ou recadastrar.
-}
buscaCliente :: String -> String -> IO ()
buscaCliente numero arqCardapio = do
	arqExiste <- doesFileExist "ClientesCadastrados.txt" -- verifica se o arquivo existe
	if not(arqExiste) 
	then do
		cadastraCliente numero arqCardapio--chamando a funcao cadastraCliente
		putStrLn ""
	else do
		appendFile "ClientesCadastrados.txt" ""  
		handle <- openFile "ClientesCadastrados.txt" ReadMode  -- abrindo no mode de ler e ligando a "handle"
		contents <- hGetContents handle
	      	let linhas = lines contents --["linha1","linha2",...] É uma lista de strings, onde cada string é uma lista
		    cadastrado = temNaLista numero linhas -- verifica se o cliente jah eh cadastrado
		if cadastrado --Jah está cadastrado
		then do --Cliente eh cadastrado
			let nomeAux = nomeDoCliente numero linhas -- 
                            nome = nomeAux !! 0
			putStrLn $ "Cliente Cadastrado: " ++ id(nome) ++ "\n[C]onfirma ou [R]ecadastra? "
			opcao <- getLine
			hClose handle
			case opcao of -- Dependendo de uma das opções chama uma respectiva função para fazer o processamento
				"C" -> funcaoCardapio arqCardapio nome numero
				"c" -> funcaoCardapio arqCardapio nome numero
				"R" -> recadastra numero linhas arqCardapio
				"r" -> recadastra numero linhas arqCardapio
		else do -- Cliente não eh cadastrado ainda
			cadastraCliente numero arqCardapio --chamando a funcao cadastraCliente
			hClose handle
			putStrLn ""



-- ##################################################   FUNÇÕES DO CARDAPIO    ############################################

-- Formata o cardapio para ser impresso na tela
formataCardapio :: [[Char]] -> IO ()
formataCardapio [] = putStrLn ""
formataCardapio (primeiro:resto) = do
	let aux = splitOn ";" primeiro
	    [codigo,_,item,preco,_,_] = aux
	putStrLn $ "\t" ++ id(codigo) ++ "\tR$ " ++ id(preco) ++ "\t\t" ++ id(item)
	formataCardapio resto



--Exibirá o arquivo cardapio. Ela chama a funcao formataCardapio para formatar a exibição do cardapio
exibeCardapio :: String -> [Char] -> String -> IO ()
exibeCardapio arquivo nomeCliente numeroTel = do
	handle <- openFile arquivo ReadMode  -- abrindo no mode de ler e ligando a "handle"
	contents <- hGetContents handle
	let porLinhas = lines contents
	formataCardapio porLinhas -- Passando o conteudo do cardapio em uma lista separada por linhas para o cardapio ser formatda e exibido na tela
	hClose handle 
	funcaoCardapio arquivo nomeCliente numeroTel
	putStrLn ""
	


-- Funcao encontrada na internet. Será usada pra substituir a "," por "."
replace :: Eq a => [a] -> [a] -> [a] -> [a]
replace [] _ _ = []
replace s find repl = -- "s" eh a string, "find" eh o q se quer substituir e "repl" eh o que será colocado no lugar de "find"
    if take (length find) s == find
        then repl ++ (replace (drop (length find) s) find repl)
        else [head s] ++ (replace (tail s) find repl)





--Passa o numero do pedido e a lista por linhas do cardapio, além do nome do cliente e seu numero de telefone
temNoCardapio :: String -> [String] -> String -> [Char] -> String -> IO ()
temNoCardapio num [] arqCardapio nomeCliente numeroTel = do
	putStrLn $ "\tNao ha item com o codigo " ++ id(num) ++ " no cardapio"
	funcaoCardapio arqCardapio nomeCliente numeroTel
	putStrLn ""


-- Verifica se existe o item pedido no cardápio. Se sim, seu valor é computado e salvo em um arquivo auxiliar "total.txt" o qual possue em 
-- cada linha o valor total do item pedido pelo cliente. O valor total da compra é a soma desses valores que estão em cada linha do arquivo.
temNoCardapio num (primeiro:resto) arqCardapio nomeCliente numeroTel = do
	let aux = splitOn ";" primeiro
	    [codigo,_,item,preco,_,_] = aux
	if (num == (aux !! 0)) --item existe no pedido
	then do
		putStrLn $ "\tAdicionando " ++ id(item) ++ " ao pedido. Quantidade:"
		quantidade <- getLine
		let quant = read quantidade 
		    precoAux = replace preco "," "."
		    precoAux2 = read precoAux :: Float -- fazendo a coerção pra float
		    soma = quant * precoAux2 
		appendFile "total.txt" (show(soma) ++ "\n")
		funcaoCardapio arqCardapio nomeCliente numeroTel
	else do
		temNoCardapio num resto arqCardapio nomeCliente numeroTel


--Recebe o numero do pedido e procura o mesmo no cardapio. Esta função chama a função temNoCardapio, definida acima
buscaItem :: String -> String -> [Char] -> String -> IO ()
buscaItem numPedido arqCardapio nomeCliente numeroTel = do
	handle <- openFile arqCardapio ReadMode  -- abrindo no mode de ler e ligando a "handle"
	contents <- hGetContents handle
	let porLinhas = lines contents
	temNoCardapio numPedido porLinhas arqCardapio nomeCliente numeroTel
	hClose handle 
	putStrLn ""


-- Verifica a opcao fornecida pelo usuário. Dada a opção, chama a respectiva função para realizar a computação escolhida
funcaoCardapio :: String -> [Char] -> String -> IO ()
funcaoCardapio arqCardapio nomeCliente numeroTel = do
	putStrLn "Adicionar item numero (? para cardapio, 0 para finalizar) "
	opcao <- getLine
	if opcao == "?" --exibe cardapio
	then do
		exibeCardapio arqCardapio nomeCliente numeroTel
		putStrLn ""
	else if opcao == "0" -- encerra pedido
	then do
		subtotal nomeCliente numeroTel
		putStrLn ""
	else do -- busca item no cardapio
		buscaItem opcao arqCardapio nomeCliente numeroTel
		putStrLn ""



-- ######################    MAIS FUNÇÕES RELACIONADAS AO CLIENTE (CADASTRO, BUSCA, ETC)        ##############################################
	
-- faz a soma do valor gasto pelo cliente
soma :: [String] -> Float
soma [] = 0
soma (primeiro:resto) = do
	let prim = read primeiro :: Float
	prim + soma resto


-- Pergunta se o usuario irá confirmar mesmo a compra. Se sim, chama a função "soma" definida acima e finaliza a compra, adicionando a informação
-- desta no arquivo pedidos do dia. O arquivo total.txt é deletado ao final da computação
-- Se o usuário desistir da compra, apenas é deletado o arquivo total.txt, sem salvar qualquer informação no arquivo pedidosDoDia
subtotal :: [Char] -> String -> IO ()
subtotal nomeCliente numeroTel = do
	appendFile "total.txt" (show(0) ++ "\n")
	handle <- openFile "total.txt" ReadMode  -- abrindo no mode de ler e ligando a "handle"
	contents <- hGetContents handle
      	let linhas = lines contents --["soma1","soma2",...]
	    total = soma linhas
	putStr $ "Total: R$ " ++ show(total) ++ " Confirma? \n"
	confirmacao <- getLine
	if confirmacao == "S" || confirmacao == "s"
	then do
		existe <- doesFileExist "pedidosDoDia.csvv"
		if existe
		then do -- se jah existe o arquivo
			let pedido = nomeCliente ++ "; " ++ numeroTel ++ "; R$ " ++ show(total) 
			appendFile "pedidosDoDia.csvv" (pedido ++ "\n")
			hClose handle 
			removeFile "total.txt"
			main -- chamando a main novamente para se iniciar o programa 
			putStrLn ""
		else do -- se nao existe, põe o cabeçalho e faz o append da informação
			appendFile "pedidosDoDia.csvv" ("Nome; Telefone; Valor Total" ++ "\n") -- cabeçalho do arquivo
			let pedido = nomeCliente ++ "; " ++ numeroTel ++ "; R$ " ++ show(total) 
			appendFile "pedidosDoDia.csvv" (pedido ++ "\n")
			hClose handle 
			removeFile "total.txt"
			main -- chamando a main novamente para se iniciar o programa 
			putStrLn ""		
	else do
		hClose handle
		removeFile "total.txt"
		main -- chamando a main novamente para se iniciar o programa 
		putStrLn ""



--Funcao para retirar um elemento da lista, dado o numero do telefone
retiraDaLista :: [Char] -> [[Char]] -> [[Char]] -> [[Char]]
retiraDaLista num listaAux lista = do
	let (primeiro:resto) = listaAux
	    aux = splitOn ";" primeiro
	    teste = (" " ++ num) `elem` aux
	if teste
	then do
		let novaLista = delete primeiro lista -- deleta a entrada da lista original
		novaLista
	else do
		retiraDaLista num resto lista --Passa o numero do telefone, o resto da lista e a lista original


-- Faz o recadastro do cliente
recadastra :: String -> [String] -> String -> IO ()
recadastra num lstPorLinhas arqCardapio = do
	let novo = retiraDaLista num lstPorLinhas lstPorLinhas
    	(tempName, tempHandle) <- openTempFile "." "temp"  -- tempName é o filePath e tempHandle o "nome" do arquivo temporario, no caso, tempXXX, onde os X's sao num aleatorios
	putStr "Nome:\n"
	nome <- getLine
	putStr "Endereco\n"
	endereco <- getLine
	putStr "Ponto de Referencia\n"
	referencia <- getLine
	let clienteLista = [nome ++ ";",endereco ++ ";",num ++ ";",referencia ++ ";"]
	hPutStr tempHandle $ ((unwords clienteLista) ++ "\n")
	hClose tempHandle  -- fecha arquivo
	appendFile tempName (unlines novo)
	removeFile "ClientesCadastrados.txt"  -- remove arquivo original
	renameFile tempName "ClientesCadastrados.txt" -- renomeio arquivo temporario com o nome do original
	buscaCliente num arqCardapio
	
	


		
-- ############## MAIN ################

main = do
	argumentos <- leituraArqEntrada
	telefone <- pegaTelefone
	if telefone == "0" -- exita o programa
	then
		putStrLn ""
	else if telefone == "" -- chama a main de novo
	then
		main
	else
		buscaCliente telefone (argumentos !! 3)
	



